searchData={"content_type":"text/markdown","items":[{"doc":"Documentation for `EctoMySQLExtras`.","ref":"EctoMySQLExtras.html","title":"EctoMySQLExtras","type":"behaviour"},{"doc":"","ref":"EctoMySQLExtras.html#connections/2","title":"EctoMySQLExtras.connections/2","type":"function"},{"doc":"","ref":"EctoMySQLExtras.html#db_settings/2","title":"EctoMySQLExtras.db_settings/2","type":"function"},{"doc":"","ref":"EctoMySQLExtras.html#db_status/2","title":"EctoMySQLExtras.db_status/2","type":"function"},{"doc":"","ref":"EctoMySQLExtras.html#dirty_pages_ratio/2","title":"EctoMySQLExtras.dirty_pages_ratio/2","type":"function"},{"doc":"","ref":"EctoMySQLExtras.html#index_size/2","title":"EctoMySQLExtras.index_size/2","type":"function"},{"doc":"","ref":"EctoMySQLExtras.html#c:info/0","title":"EctoMySQLExtras.info/0","type":"callback"},{"doc":"","ref":"EctoMySQLExtras.html#long_running_queries/2","title":"EctoMySQLExtras.long_running_queries/2","type":"function"},{"doc":"","ref":"EctoMySQLExtras.html#plugins/2","title":"EctoMySQLExtras.plugins/2","type":"function"},{"doc":"","ref":"EctoMySQLExtras.html#queries/1","title":"EctoMySQLExtras.queries/1","type":"function"},{"doc":"","ref":"EctoMySQLExtras.html#c:query/1","title":"EctoMySQLExtras.query/1","type":"callback"},{"doc":"Run a query with `name`, on `repo`, in the given `format`.\nThe `repo` can be a module name or a tuple like `{module, node}`.","ref":"EctoMySQLExtras.html#query/3","title":"EctoMySQLExtras.query/3","type":"function"},{"doc":"* `:format` - The format that results will return. Accepts `:ascii` or `:raw`.\n    If `:ascii` a nice table printed in ASCII - a string will be returned.\n    Otherwise a result struct will be returned. This option is required.\n\n  * `:args` - Overwrites the default arguments for the given query. You can\n    check the defaults of each query in its modules defined in this project.\n\n  * `:query_opts` - Overwrites the default options for the Ecto query.\n    Defaults to [log: false]","ref":"EctoMySQLExtras.html#query/3-options","title":"Options - EctoMySQLExtras.query/3","type":"function"},{"doc":"","ref":"EctoMySQLExtras.html#records_rank/2","title":"EctoMySQLExtras.records_rank/2","type":"function"},{"doc":"","ref":"EctoMySQLExtras.html#table_cache/2","title":"EctoMySQLExtras.table_cache/2","type":"function"},{"doc":"","ref":"EctoMySQLExtras.html#table_indexes_size/2","title":"EctoMySQLExtras.table_indexes_size/2","type":"function"},{"doc":"","ref":"EctoMySQLExtras.html#table_size/2","title":"EctoMySQLExtras.table_size/2","type":"function"},{"doc":"","ref":"EctoMySQLExtras.html#total_index_size/2","title":"EctoMySQLExtras.total_index_size/2","type":"function"},{"doc":"","ref":"EctoMySQLExtras.html#total_table_size/2","title":"EctoMySQLExtras.total_table_size/2","type":"function"},{"doc":"","ref":"EctoMySQLExtras.html#unused_indexes/2","title":"EctoMySQLExtras.unused_indexes/2","type":"function"},{"doc":"","ref":"EctoMySQLExtras.html#waits_for_checkpoint/2","title":"EctoMySQLExtras.waits_for_checkpoint/2","type":"function"},{"doc":"","ref":"EctoMySQLExtras.html#waits_for_redolog/2","title":"EctoMySQLExtras.waits_for_redolog/2","type":"function"},{"doc":"","ref":"EctoMySQLExtras.html#t:repo/0","title":"EctoMySQLExtras.repo/0","type":"type"},{"doc":"Query active connections.\n\n  Data is retrieved from the `performance_schema` or `information_schema` table.","ref":"EctoMySQLExtras.Connections.html","title":"EctoMySQLExtras.Connections","type":"module"},{"doc":"","ref":"EctoMySQLExtras.Connections.html#info/0","title":"EctoMySQLExtras.Connections.info/0","type":"function"},{"doc":"","ref":"EctoMySQLExtras.Connections.html#query/1","title":"EctoMySQLExtras.Connections.query/1","type":"function"},{"doc":"Query global variables.\n\nData is retrieved from the `performance_schema` or `information_schema` database and the `global_variables` table.\nIt also provides `InnoDB` specific variables.","ref":"EctoMySQLExtras.DbSettings.html","title":"EctoMySQLExtras.DbSettings","type":"module"},{"doc":"","ref":"EctoMySQLExtras.DbSettings.html#info/0","title":"EctoMySQLExtras.DbSettings.info/0","type":"function"},{"doc":"","ref":"EctoMySQLExtras.DbSettings.html#query/1","title":"EctoMySQLExtras.DbSettings.query/1","type":"function"},{"doc":"Query global status.\n\nData is retrieved from the `performance_schema` database and the `global_status` table.\nIt also provides `InnoDB` specific variables.","ref":"EctoMySQLExtras.DbStatus.html","title":"EctoMySQLExtras.DbStatus","type":"module"},{"doc":"","ref":"EctoMySQLExtras.DbStatus.html#info/0","title":"EctoMySQLExtras.DbStatus.info/0","type":"function"},{"doc":"","ref":"EctoMySQLExtras.DbStatus.html#query/1","title":"EctoMySQLExtras.DbStatus.query/1","type":"function"},{"doc":"InnoDB dirty pages ratio.\n\nThe ratio of how often InnoDB needs to be flushed. During the write-heavy load,\nit is normal that this percentage increases. A good value should be 75% and below.\n\nData is retrieved from the `performance_schema` or `information_schema` database and the `global_status` table.","ref":"EctoMySQLExtras.DirtyPagesRatio.html","title":"EctoMySQLExtras.DirtyPagesRatio","type":"module"},{"doc":"","ref":"EctoMySQLExtras.DirtyPagesRatio.html#info/0","title":"EctoMySQLExtras.DirtyPagesRatio.info/0","type":"function"},{"doc":"","ref":"EctoMySQLExtras.DirtyPagesRatio.html#query/1","title":"EctoMySQLExtras.DirtyPagesRatio.query/1","type":"function"},{"doc":"Query the size of each index in the `Ecto.Repo` database.\n\nData is retrieved from the `mysql` database and the `innodb_index_stats` table.\nThis query will only work for databases that use `InnoDB` engine.\nPrimary keys are excluded from the query.","ref":"EctoMySQLExtras.IndexSize.html","title":"EctoMySQLExtras.IndexSize","type":"module"},{"doc":"","ref":"EctoMySQLExtras.IndexSize.html#info/0","title":"EctoMySQLExtras.IndexSize.info/0","type":"function"},{"doc":"","ref":"EctoMySQLExtras.IndexSize.html#query/1","title":"EctoMySQLExtras.IndexSize.query/1","type":"function"},{"doc":"Query all long running queries.\n\nData is retrieved from the `information_schema` database and the `plugins` table.\nThe `:threshold` argument is in milliseconds. The duration for MySQL is displayed\nin seconds, for MariaDB this is in millieseconds.\nAt this moment it isn't converted to a more human readable\nformat.","ref":"EctoMySQLExtras.LongRunningQueries.html","title":"EctoMySQLExtras.LongRunningQueries","type":"module"},{"doc":"","ref":"EctoMySQLExtras.LongRunningQueries.html#info/0","title":"EctoMySQLExtras.LongRunningQueries.info/0","type":"function"},{"doc":"","ref":"EctoMySQLExtras.LongRunningQueries.html#query/1","title":"EctoMySQLExtras.LongRunningQueries.query/1","type":"function"},{"doc":"Output MySQL queries to the requested format.\n\nFormats:\n* `raw`: The raw MySQL query result (%MyXQL.Result{})\n* `ascii`: The query result formatted to ASCII.","ref":"EctoMySQLExtras.Output.html","title":"EctoMySQLExtras.Output","type":"module"},{"doc":"","ref":"EctoMySQLExtras.Output.html#format/3","title":"EctoMySQLExtras.Output.format/3","type":"function"},{"doc":"Output MySQL queries to ASCII format using `:table_rex` library.","ref":"EctoMySQLExtras.OutputAscii.html","title":"EctoMySQLExtras.OutputAscii","type":"module"},{"doc":"","ref":"EctoMySQLExtras.OutputAscii.html#format/2","title":"EctoMySQLExtras.OutputAscii.format/2","type":"function"},{"doc":"","ref":"EctoMySQLExtras.OutputAscii.html#format_value/1","title":"EctoMySQLExtras.OutputAscii.format_value/1","type":"function"},{"doc":"Query all installed plugins.\n\nData is retrieved from the `information_schema` database and the `plugins` table.","ref":"EctoMySQLExtras.Plugins.html","title":"EctoMySQLExtras.Plugins","type":"module"},{"doc":"","ref":"EctoMySQLExtras.Plugins.html#info/0","title":"EctoMySQLExtras.Plugins.info/0","type":"function"},{"doc":"","ref":"EctoMySQLExtras.Plugins.html#query/1","title":"EctoMySQLExtras.Plugins.query/1","type":"function"},{"doc":"Query the estimated rows of each table in the `Ecto.Repo` database.\n\nData is retrieved from the `information_schema` database and the `tables` table.","ref":"EctoMySQLExtras.RecordsRank.html","title":"EctoMySQLExtras.RecordsRank","type":"module"},{"doc":"","ref":"EctoMySQLExtras.RecordsRank.html#info/0","title":"EctoMySQLExtras.RecordsRank.info/0","type":"function"},{"doc":"","ref":"EctoMySQLExtras.RecordsRank.html#query/1","title":"EctoMySQLExtras.RecordsRank.query/1","type":"function"},{"doc":"InnoDB waits for redolog.\n\nTable cache ratio.\n\n- `cache_ratio`: The ratio of table cache usage for all threads.\nA good value should be less than 80%. Increase the table_open_cache variable until the percentage reaches a good value.\n- `hit_ratio`: The ratio of table cache hit usage.\nA good hit ratio value should be 90% and above. Otherwise, increase the table_open_cache variable until the hit ratio reaches a good value.\n\nData is retrieved from the `performance_schema` or `information_schema` database and the `global_status` table.","ref":"EctoMySQLExtras.TableCache.html","title":"EctoMySQLExtras.TableCache","type":"module"},{"doc":"","ref":"EctoMySQLExtras.TableCache.html#info/0","title":"EctoMySQLExtras.TableCache.info/0","type":"function"},{"doc":"","ref":"EctoMySQLExtras.TableCache.html#query/1","title":"EctoMySQLExtras.TableCache.query/1","type":"function"},{"doc":"Query the total size of indexes for each table in the `Ecto.Repo` database.\n\nPrimary indexes are not included since InnoDB uses it as the clustered index,\nthe size represents the table itself.\n\nData is retrieved from the `information_schema` database and the `tables` table.","ref":"EctoMySQLExtras.TableIndexesSize.html","title":"EctoMySQLExtras.TableIndexesSize","type":"module"},{"doc":"","ref":"EctoMySQLExtras.TableIndexesSize.html#info/0","title":"EctoMySQLExtras.TableIndexesSize.info/0","type":"function"},{"doc":"","ref":"EctoMySQLExtras.TableIndexesSize.html#query/1","title":"EctoMySQLExtras.TableIndexesSize.query/1","type":"function"},{"doc":"Query the total size of each table in the `Ecto.Repo` database.\n\nData is retrieved from the `information_schema` database and the `tables` table.","ref":"EctoMySQLExtras.TableSize.html","title":"EctoMySQLExtras.TableSize","type":"module"},{"doc":"","ref":"EctoMySQLExtras.TableSize.html#info/0","title":"EctoMySQLExtras.TableSize.info/0","type":"function"},{"doc":"","ref":"EctoMySQLExtras.TableSize.html#query/1","title":"EctoMySQLExtras.TableSize.query/1","type":"function"},{"doc":"Query the total size of all indexes in the `Ecto.Repo` database.\n\nPrimary indexes are not included since InnoDB uses it as the clustered index,\nthe size represents the table itself.\n\nData is retrieved from the `information_schema` database and the `tables` table.","ref":"EctoMySQLExtras.TotalIndexSize.html","title":"EctoMySQLExtras.TotalIndexSize","type":"module"},{"doc":"","ref":"EctoMySQLExtras.TotalIndexSize.html#info/0","title":"EctoMySQLExtras.TotalIndexSize.info/0","type":"function"},{"doc":"","ref":"EctoMySQLExtras.TotalIndexSize.html#query/1","title":"EctoMySQLExtras.TotalIndexSize.query/1","type":"function"},{"doc":"Query the total size of each table in the `Ecto.Repo` database.\n\nData is retrieved from the `information_schema` database and the `tables` table.","ref":"EctoMySQLExtras.TotalTableSize.html","title":"EctoMySQLExtras.TotalTableSize","type":"module"},{"doc":"","ref":"EctoMySQLExtras.TotalTableSize.html#info/0","title":"EctoMySQLExtras.TotalTableSize.info/0","type":"function"},{"doc":"","ref":"EctoMySQLExtras.TotalTableSize.html#query/1","title":"EctoMySQLExtras.TotalTableSize.query/1","type":"function"},{"doc":"Query all unused indexes.\n\nData is retrieved from the `performance_schema` database and the `table_io_waits_summary_by_index_usage` table.\nThe database should be running for a while since unused indexes are tracked based on IO activity.\nAn index is considered unused when it has 0 hits and almost unused when it has 50 hits or less. The latter can however\nbe configured by passing: `min_hits` as an argument. Also indexes of small tables (less than 5 pages) are excluded.\nPrimary keys are excluded from the query.","ref":"EctoMySQLExtras.UnusedIndexes.html","title":"EctoMySQLExtras.UnusedIndexes","type":"module"},{"doc":"","ref":"EctoMySQLExtras.UnusedIndexes.html#info/0","title":"EctoMySQLExtras.UnusedIndexes.info/0","type":"function"},{"doc":"","ref":"EctoMySQLExtras.UnusedIndexes.html#query/1","title":"EctoMySQLExtras.UnusedIndexes.query/1","type":"function"},{"doc":"InnoDB waits for checkpoint.\n\nThe ratio of how often InnoDB needs to read or create a page where no clean pages are available.\nA good ratio value should stay below 1.\n\nIf `innodb_buffer_pool_wait_free` (`wait_counter`) is greater than 0, it is a strong indicator that the InnoDB buffer pool is too small,\nand operations had to wait on a checkpoint.\n\nData is retrieved from the `performance_schema` or `information_schema` database and the `global_status` table.","ref":"EctoMySQLExtras.WaitsForCheckpoint.html","title":"EctoMySQLExtras.WaitsForCheckpoint","type":"module"},{"doc":"","ref":"EctoMySQLExtras.WaitsForCheckpoint.html#info/0","title":"EctoMySQLExtras.WaitsForCheckpoint.info/0","type":"function"},{"doc":"","ref":"EctoMySQLExtras.WaitsForCheckpoint.html#query/1","title":"EctoMySQLExtras.WaitsForCheckpoint.query/1","type":"function"},{"doc":"InnoDB waits for redolog.\n\nThe ratio of redo log contention.\nA good ratio value should stay below 1.\n\nCheck `innodb_log_waits` and if it continues to increase then it is a strong indicator that the InnoDB buffer pool is too small.\nIt can also mean that the disks are too slow and cannot sustain the disk IO, perhaps due to peak write load.\n\nData is retrieved from the `performance_schema` or `information_schema` database and the `global_status` table.","ref":"EctoMySQLExtras.WaitsForRedolog.html","title":"EctoMySQLExtras.WaitsForRedolog","type":"module"},{"doc":"","ref":"EctoMySQLExtras.WaitsForRedolog.html#info/0","title":"EctoMySQLExtras.WaitsForRedolog.info/0","type":"function"},{"doc":"","ref":"EctoMySQLExtras.WaitsForRedolog.html#query/1","title":"EctoMySQLExtras.WaitsForRedolog.query/1","type":"function"},{"doc":"# Changelog\n\nAll notable changes to this project will be documented in this file.\n\nThe format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/),\nand this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"","ref":"changelog.html#v0-6-2-2024-02-03","title":"v0.6.2 (2024-02-03) - Changelog","type":"extras"},{"doc":"* Relax `table_rex` version to `~> 3.1` or `~> 4.0`\n* Support MySQL 8.1\n* Support MariaDB 11.0 and 11.1\n* Drop MariaDB 10.9 and 10.10\n* Bump deps\n* Delete unused dependencies in `mix.lock`","ref":"changelog.html#changed","title":"Changed - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v0-6-1-2023-07-29","title":"v0.6.1 (2023-07-29) - Changelog","type":"extras"},{"doc":"* Bump deps\n* Drop MariaDB 10.3\n* Support MariaDB 10.9, 10.10, 10.11","ref":"changelog.html#changed","title":"Changed - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v0-6-0-2022-11-02","title":"v0.6.0 (2022-11-02) - Changelog","type":"extras"},{"doc":"* List active connections","ref":"changelog.html#added","title":"Added - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v0-5-0-2022-05-25","title":"v0.5.0 (2022-05-25) - Changelog","type":"extras"},{"doc":"* Support `query_opts` with `log` option to enable/disable logging (disabled by default)","ref":"changelog.html#added","title":"Added - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v0-4-2-2022-05-09","title":"v0.4.2 (2022-05-09) - Changelog","type":"extras"},{"doc":"* Drop MariaDB 10.2\n* Fix README.md links and docs","ref":"changelog.html#changed","title":"Changed - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v0-4-1-2022-01-17","title":"v0.4.1 (2022-01-17) - Changelog","type":"extras"},{"doc":"* Bump deps","ref":"changelog.html#changed","title":"Changed - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v0-4-0-2021-12-24","title":"v0.4.0 (2021-12-24) - Changelog","type":"extras"},{"doc":"* InnoDB Dirty pages ratio query #11\n* InnoDB Waits for checkpoint query #12\n* InnoDB Waits for redolog query #13\n* Table cache query #14","ref":"changelog.html#added","title":"Added - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v0-3-1-2021-11-03","title":"v0.3.1 (2021-11-03) - Changelog","type":"extras"},{"doc":"* Support MariaDB 10.2, 10.3, 10.4\n\n#","ref":"changelog.html#added","title":"Added - Changelog","type":"extras"},{"doc":"* Deleted `max_memory_used` from Long running queries\n* Misc doc changes (#5)","ref":"changelog.html#changed","title":"Changed - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v0-3-0-2021-10-19","title":"v0.3.0 (2021-10-19) - Changelog","type":"extras"},{"doc":"* Test MariaDB 10.6 in CI\n* Query: Long running queries (#1)\n\n#","ref":"changelog.html#added","title":"Added - Changelog","type":"extras"},{"doc":"* Renamed `DBStatus` to `DbStatus`\n* Pass query arguments inside `args` keyword list\n\n#","ref":"changelog.html#changed","title":"Changed - Changelog","type":"extras"},{"doc":"* Convert Total table size to unsigned integer inside SQL query","ref":"changelog.html#fixed","title":"Fixed - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v0-2-1-2021-10-14","title":"v0.2.1 (2021-10-14) - Changelog","type":"extras"},{"doc":"* Compile error when table_rex isn't loaded","ref":"changelog.html#fixed","title":"Fixed - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v0-2-0-2021-10-11","title":"v0.2.0 (2021-10-11) - Changelog","type":"extras"},{"doc":"* Test MySQL 5.7 in CI\n* Query: DB settings\n* Query: DB status\n* Query: Unused indexes\n* Query: Records rank\n\n#","ref":"changelog.html#added","title":"Added - Changelog","type":"extras"},{"doc":"* Delete views from query results\n* Exclude Primary key from Index size query\n\n#","ref":"changelog.html#changed","title":"Changed - Changelog","type":"extras"},{"doc":"* Don't convert total index size inside SQL query","ref":"changelog.html#fixed","title":"Fixed - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v0-1-0-2021-10-07","title":"v0.1.0 (2021-10-07) - Changelog","type":"extras"},{"doc":"* Initial commit\n* Query: Index Size\n* Query: Plugins\n* Query: Table indexes size\n* Query: Table size\n* Query: Total index size\n* Query: Total table size","ref":"changelog.html#added","title":"Added - Changelog","type":"extras"},{"doc":"Apache License\n                           Version 2.0, January 2004\n                        http://www.apache.org/licenses/\n\n   TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION\n\n   1. Definitions.\n\n      \"License\" shall mean the terms and conditions for use, reproduction,\n      and distribution as defined by Sections 1 through 9 of this document.\n\n      \"Licensor\" shall mean the copyright owner or entity authorized by\n      the copyright owner that is granting the License.\n\n      \"Legal Entity\" shall mean the union of the acting entity and all\n      other entities that control, are controlled by, or are under common\n      control with that entity. For the purposes of this definition,\n      \"control\" means (i) the power, direct or indirect, to cause the\n      direction or management of such entity, whether by contract or\n      otherwise, or (ii) ownership of fifty percent (50%) or more of the\n      outstanding shares, or (iii) beneficial ownership of such entity.\n\n      \"You\" (or \"Your\") shall mean an individual or Legal Entity\n      exercising permissions granted by this License.\n\n      \"Source\" form shall mean the preferred form for making modifications,\n      including but not limited to software source code, documentation\n      source, and configuration files.\n\n      \"Object\" form shall mean any form resulting from mechanical\n      transformation or translation of a Source form, including but\n      not limited to compiled object code, generated documentation,\n      and conversions to other media types.\n\n      \"Work\" shall mean the work of authorship, whether in Source or\n      Object form, made available under the License, as indicated by a\n      copyright notice that is included in or attached to the work\n      (an example is provided in the Appendix below).\n\n      \"Derivative Works\" shall mean any work, whether in Source or Object\n      form, that is based on (or derived from) the Work and for which the\n      editorial revisions, annotations, elaborations, or other modifications\n      represent, as a whole, an original work of authorship. For the purposes\n      of this License, Derivative Works shall not include works that remain\n      separable from, or merely link (or bind by name) to the interfaces of,\n      the Work and Derivative Works thereof.\n\n      \"Contribution\" shall mean any work of authorship, including\n      the original version of the Work and any modifications or additions\n      to that Work or Derivative Works thereof, that is intentionally\n      submitted to Licensor for inclusion in the Work by the copyright owner\n      or by an individual or Legal Entity authorized to submit on behalf of\n      the copyright owner. For the purposes of this definition, \"submitted\"\n      means any form of electronic, verbal, or written communication sent\n      to the Licensor or its representatives, including but not limited to\n      communication on electronic mailing lists, source code control systems,\n      and issue tracking systems that are managed by, or on behalf of, the\n      Licensor for the purpose of discussing and improving the Work, but\n      excluding communication that is conspicuously marked or otherwise\n      designated in writing by the copyright owner as \"Not a Contribution.\"\n\n      \"Contributor\" shall mean Licensor and any individual or Legal Entity\n      on behalf of whom a Contribution has been received by Licensor and\n      subsequently incorporated within the Work.\n\n   2. Grant of Copyright License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      copyright license to reproduce, prepare Derivative Works of,\n      publicly display, publicly perform, sublicense, and distribute the\n      Work and such Derivative Works in Source or Object form.\n\n   3. Grant of Patent License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      (except as stated in this section) patent license to make, have made,\n      use, offer to sell, sell, import, and otherwise transfer the Work,\n      where such license applies only to those patent claims licensable\n      by such Contributor that are necessarily infringed by their\n      Contribution(s) alone or by combination of their Contribution(s)\n      with the Work to which such Contribution(s) was submitted. If You\n      institute patent litigation against any entity (including a\n      cross-claim or counterclaim in a lawsuit) alleging that the Work\n      or a Contribution incorporated within the Work constitutes direct\n      or contributory patent infringement, then any patent licenses\n      granted to You under this License for that Work shall terminate\n      as of the date such litigation is filed.\n\n   4. Redistribution. You may reproduce and distribute copies of the\n      Work or Derivative Works thereof in any medium, with or without\n      modifications, and in Source or Object form, provided that You\n      meet the following conditions:\n\n      (a) You must give any other recipients of the Work or\n          Derivative Works a copy of this License; and\n\n      (b) You must cause any modified files to carry prominent notices\n          stating that You changed the files; and\n\n      (c) You must retain, in the Source form of any Derivative Works\n          that You distribute, all copyright, patent, trademark, and\n          attribution notices from the Source form of the Work,\n          excluding those notices that do not pertain to any part of\n          the Derivative Works; and\n\n      (d) If the Work includes a \"NOTICE\" text file as part of its\n          distribution, then any Derivative Works that You distribute must\n          include a readable copy of the attribution notices contained\n          within such NOTICE file, excluding those notices that do not\n          pertain to any part of the Derivative Works, in at least one\n          of the following places: within a NOTICE text file distributed\n          as part of the Derivative Works; within the Source form or\n          documentation, if provided along with the Derivative Works; or,\n          within a display generated by the Derivative Works, if and\n          wherever such third-party notices normally appear. The contents\n          of the NOTICE file are for informational purposes only and\n          do not modify the License. You may add Your own attribution\n          notices within Derivative Works that You distribute, alongside\n          or as an addendum to the NOTICE text from the Work, provided\n          that such additional attribution notices cannot be construed\n          as modifying the License.\n\n      You may add Your own copyright statement to Your modifications and\n      may provide additional or different license terms and conditions\n      for use, reproduction, or distribution of Your modifications, or\n      for any such Derivative Works as a whole, provided Your use,\n      reproduction, and distribution of the Work otherwise complies with\n      the conditions stated in this License.\n\n   5. Submission of Contributions. Unless You explicitly state otherwise,\n      any Contribution intentionally submitted for inclusion in the Work\n      by You to the Licensor shall be under the terms and conditions of\n      this License, without any additional terms or conditions.\n      Notwithstanding the above, nothing herein shall supersede or modify\n      the terms of any separate license agreement you may have executed\n      with Licensor regarding such Contributions.\n\n   6. Trademarks. This License does not grant permission to use the trade\n      names, trademarks, service marks, or product names of the Licensor,\n      except as required for reasonable and customary use in describing the\n      origin of the Work and reproducing the content of the NOTICE file.\n\n   7. Disclaimer of Warranty. Unless required by applicable law or\n      agreed to in writing, Licensor provides the Work (and each\n      Contributor provides its Contributions) on an \"AS IS\" BASIS,\n      WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or\n      implied, including, without limitation, any warranties or conditions\n      of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A\n      PARTICULAR PURPOSE. You are solely responsible for determining the\n      appropriateness of using or redistributing the Work and assume any\n      risks associated with Your exercise of permissions under this License.\n\n   8. Limitation of Liability. In no event and under no legal theory,\n      whether in tort (including negligence), contract, or otherwise,\n      unless required by applicable law (such as deliberate and grossly\n      negligent acts) or agreed to in writing, shall any Contributor be\n      liable to You for damages, including any direct, indirect, special,\n      incidental, or consequential damages of any character arising as a\n      result of this License or out of the use or inability to use the\n      Work (including but not limited to damages for loss of goodwill,\n      work stoppage, computer failure or malfunction, or any and all\n      other commercial damages or losses), even if such Contributor\n      has been advised of the possibility of such damages.\n\n   9. Accepting Warranty or Additional Liability. While redistributing\n      the Work or Derivative Works thereof, You may choose to offer,\n      and charge a fee for, acceptance of support, warranty, indemnity,\n      or other liability obligations and/or rights consistent with this\n      License. However, in accepting such obligations, You may act only\n      on Your own behalf and on Your sole responsibility, not on behalf\n      of any other Contributor, and only if You agree to indemnify,\n      defend, and hold each Contributor harmless for any liability\n      incurred by, or claims asserted against, such Contributor by reason\n      of your accepting any such warranty or additional liability.\n\n   END OF TERMS AND CONDITIONS","ref":"license.html","title":"License","type":"extras"},{"doc":"# Ecto MySQL Extras\n\n[![CI](https://github.com/timothyvanderaerden/ecto_mysql_extras/actions/workflows/ci.yml/badge.svg)](https://github.com/timothyvanderaerden/ecto_mysql_extras/actions/workflows/ci.yml)\n[![codecov](https://codecov.io/gh/timothyvanderaerden/ecto_mysql_extras/branch/main/graph/badge.svg?token=IJMNEMI6CE)](https://codecov.io/gh/timothyvanderaerden/ecto_mysql_extras)\n[![Module Version](https://img.shields.io/hexpm/v/ecto_mysql_extras.svg)](https://hex.pm/packages/ecto_mysql_extras)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-lightgreen.svg)](https://hexdocs.pm/ecto_mysql_extras/)\n[![Total Download](https://img.shields.io/hexpm/dt/ecto_mysql_extras.svg)](https://hex.pm/packages/ecto_mysql_extras)\n[![License](https://img.shields.io/hexpm/l/ecto_mysql_extras.svg)](https://github.com/timothyvanderaerden/ecto_mysql_extras/blob/main/LICENSE)\n[![Last Updated](https://img.shields.io/github/last-commit/timothyvanderaerden/ecto_mysql_extras.svg)](https://github.com/timothyvanderaerden/ecto_mysql_extras/commits/main)\n\nThis library provides performance insight information on MySQL (and MariaDB) databases.\nIt's heavily based upon [Ecto PSQL Extras](https://github.com/pawurb/ecto_psql_extras), it reuses most of the design.\n\nThis library is an optional dependency of [Phoenix.LiveDashboard](https://hexdocs.pm/phoenix_live_dashboard/Phoenix.LiveDashboard.html).\n\n![Phoenix Ecto LiveDashboard](https://github.com/timothyvanderaerden/ecto_mysql_extras/raw/main/phoenix_live_dashboard.png)\n\nCurrently only `InnoDB` is supported, other engines may work but not all queries will return all or correct data.\n\nThe following databases are supported:\n\n* MySQL >= 5.7, <= 8.1\n* MariaDB >= 10.4, <= 11.1\n\nNewer version are tested every week to check for any compatibility issues.\n\n[![Test latest DB weekly](https://github.com/timothyvanderaerden/ecto_mysql_extras/actions/workflows/weekly-test.yml/badge.svg)](https://github.com/timothyvanderaerden/ecto_mysql_extras/actions/workflows/weekly-test.yml)","ref":"readme.html","title":"Overview","type":"extras"},{"doc":"The package can be installed by adding `:ecto_mysql_extras` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:ecto_mysql_extras, \"~> 0.6.0\"}\n  ]\nend\n```\n\n#","ref":"readme.html#installation","title":"Installation - Overview","type":"extras"},{"doc":"The configured user should have read (SELECT) access on the `mysql`, `information_schema` and `performance_schema` database. Specifically for the following schemas:\n\n* `mysql.innodb_index_stats`\n* `performance_schema.table_io_waits_summary_by_index_usage`\n\nAn example on how to achieve this can be found in `docker/init/init.sql`.\n\n#","ref":"readme.html#mysql-mariadb-configuration","title":"MySQL/MariaDB configuration - Overview","type":"extras"},{"doc":"The performance schema is enabled by default for MySQL databases but not for MariaDB. To enable this add `performance_schema=ON` to `my.cnf`. A restart is need to take effect.\n\nMore information: https://mariadb.com/kb/en/performance-schema-overview/","ref":"readme.html#performance-schema","title":"Performance schema - Overview","type":"extras"},{"doc":"To run a query:\n\n```elixir\nEctoMySQLExtras.plugins(MyApp.Repo)\n```\nThis will return a `%MyXQL.Result{}` struct. If you want to display it in a more human readable (ASCII) way:\n\n```elixir\nEctoMySQLExtras.plugins(MyApp.Repo, format: :ascii)\n```\n\nBy default query logging is disabled, to enable logging you can do the following:\n```elixir\nEctoMySQLExtras.plugins(MyApp.Repo, query_opts: [log: true])\n```\n\nTo view all available queries:\n\n```elixir\nEctoMySQLExtras.queries()\n```\n\n### `connections`\n\n```\nEctoMySQLExtras.connections(MyApp.Repo, format: :ascii)\n\n+-------------------------------------------------------------------------------------+\n|                                  Active Connections                                 |\n+-----+------+-----------------+-------+---------+------+----------------------+------+\n| id  | user | host            | db    | command | time | state                | info |\n+-----+------+-----------------+-------+---------+------+----------------------+------+\n| 466 | root | localhost:49864 | my_db | Sleep   | 1    |                      |      |\n| 465 | root | localhost:49854 | my_db | Sleep   | 1    |                      |      |\n(truncated results for brevity)\n```\n\nShows all active connections.\n\n### `db_settings`\n\n```\nEctoMySQLExtras.db_settings(MyApp.Repo, format: :ascii)\n\n+--------------------------------------------+\n|           MySQL global variables           |\n+--------------------------------+-----------+\n| name                           | value     |\n+--------------------------------+-----------+\n| INNODB_BUFFER_POOL_INSTANCES   | 1         |\n| INNODB_BUFFER_POOL_SIZE        | 134217728 |\n(truncated results for brevity)\n```\n\nShows global variables for selected MySQL settings.\n\n### `db_status`\n\n```\nEctoMySQLExtras.db_status(MyApp.Repo, format: :ascii)\n\n+---------------------------------+\n|       MySQL global status       |\n+----------------------+----------+\n| name                 | value    |\n+----------------------+----------+\n| Aborted_clients      | 100      |\n| Aborted_connects     | 25       |\n(truncated results for brevity)\n```\n\nShows global status for selected MySQL server status.\n\n### `dirty_pages_ratio`\n\n```\nEctoMySQLExtras.dirty_pages_ratio(MyApp.Repo, format: :ascii)\n\n+------------------------------------+\n|      InnoDB Dirty Pages Ratio      |\n+----------------------+-------------+\n| ratio                | total_pages |\n+----------------------+-------------+\n| 0.024798512089274645 | \"8065\"      |\n+----------------------+-------------+\n```\n\nShows InnoDB dirty pages ratio.\nThe ratio of how often InnoDB needs to be flushed. During the write-heavy load, it is normal that this percentage increases.\nA good value should be 75% and below.\n\n### `index_size`\n\n```\nEctoMySQLExtras.index_size(MyApp.Repo, format: :ascii)\n\n+---------------------------------------------------+\n|      Size of the indexes, descending by size      |\n+----------+-------+-------------+-------+----------+\n| schema   | name  | index       | pages | size     |\n+----------+-------+-------------+-------+----------+\n| sportsdb | stats | IDX_stats_1 | 97    | 1.5 MB   |\n| sportsdb | stats | IDX_stats_5 | 23    | 368.0 KB |\n(truncated results for brevity)\n```\n\nShows the size of each index in the database, excluding primary keys. Additionally a table can be passed to only get indexes from that table.\n\n```\nEctoMySQLExtras.index_size(MyApp.Repo, format: :ascii, args: [table: \"my_table\"])\n```\n\n### `long_running_queries`\n\n```\nEctoMySQLExtras.long_running_queries(MyApp.Repo, format: :ascii)\n\n+------------------------------------------------------------------------------+\n|         All queries longer than the threshold by descending duration         |\n+----+--------+------+------+----------+-------+-------------+-----------------+\n| id | thread | user | host | duration | query | memory_used | max_memory_used |\n+----+--------+------+------+----------+-------+-------------+-----------------+\n(truncated results for brevity)\n```\n\nShows queries that have been running for longer than 0.5 seconds, descending by duration. The threshold can be configured and is represented in milliseconds, however for MySQL servers this is converted to seconds.\n\n```\nEctoMySQLExtras.long_running_queries(MyApp.Repo, format: :ascii, args: [threshold: 1000])\n```\n\n### `plugins`\n\n```\nEctoMySQLExtras.plugins(MyApp.Repo, format: :ascii)\n\n+--------------------------------------------------------------------------------------------------------------------------------------+\n|                                                     Available and installed plugins                                                  |\n+-----------------------+---------+--------+----------------+--------------------------------------------------------------------------+\n| name                  | version | status | type           | description                                                              |\n+-----------------------+---------+--------+----------------+--------------------------------------------------------------------------+\n| binlog                | 1.0     | ACTIVE | STORAGE ENGINE | This is a pseudo storage engine to represent the binlog in a transaction |\n| mysql_native_password | 1.0     | ACTIVE | AUTHENTICATION | Native MySQL authentication                                              |\n(truncated results for brevity)\n```\n\nShows all installed plugins, their version and status.\n\n### `records_rank`\n\n\n```\nEctoMySQLExtras.records_rank(MyApp.Repo, format: :ascii)\n\n+-----------------------------------------------------------------------------------------+\n|  All tables and the number of rows in each table ordered by number of rows descending   |\n+-------------+------------------------------------------+-----------+--------------------+\n| schema      | name                                     | engine    | estimated_count    |\n+-------------+------------------------------------------+-----------+--------------------+\n| sportsdb    | affiliations_events                      | InnoDB    | 13203              |\n| sportsdb    | participants_events                      | InnoDB    | 8533               |\n(truncated results for brevity)\n```\n\nShows an estimated count of rows per table, descending by estimated count. Additionally a table can be passed to only get an estimated count from that table.\n\n```\nEctoMySQLExtras.records_rank(MyApp.Repo, format: :ascii, args: [table: \"my_table\"])\n```\n\n### `table_cache`\n\n```\nEctoMySQLExtras.table_cache(MyApp.Repo, format: :ascii)\n\n+----------------------------------------+\n|           Table cache ratio            |\n+--------------------+-------------------+\n| cache_ratio        | hit_ratio         |\n+--------------------+-------------------+\n| 10.567458019687319 | 98.08219178082192 |\n+--------------------+-------------------+\n```\n\n- `cache_ratio`: The ratio of table cache usage for all threads.\n  A good value should be less than 80%. Increase the table_open_cache variable until the percentage reaches a good value.\n- `hit_ratio`: The ratio of table cache hit usage.\n  A good hit ratio value should be 90% and above. Otherwise, increase the table_open_cache variable until the hit ratio reaches a good value\n\n\n### `table_indexes_size`\n\n```\nEctoMySQLExtras.table_indexes_size(MyApp.Repo, format: :ascii)\n\n+------------------------------------------------------------------------------------------------+\n|  Total size of all the indexes on each table (excluding PRIMARY indexes), descending by size   |\n+----------------+---------------------------------------------+--------------+------------------+\n| schema         | name                                        | engine       | index_size       |\n+----------------+---------------------------------------------+--------------+------------------+\n| sportsdb       | stats                                       | InnoDB       | 3.3 MB           |\n| sportsdb       | participants_events                         | InnoDB       | 880.0 KB         |\n(truncated results for brevity)\n```\n\nShows the total size of all indexes in a table, descending by size. Primary indexes are not included. This also requires InnoDB as engine. Additionally a table can be passed to only get the total size of all indexes from that table.\n\n```\nEctoMySQLExtras.table_indexes_size(MyApp.Repo, format: :ascii, args: [table: \"my_table\"])\n```\n\n### `table_size`\n\n```\nEctoMySQLExtras.table_size(MyApp.Repo, format: :ascii)\n\n+----------------------------------------------------------------------+\n|      Size of the tables (excluding indexes), descending by size      |\n+----------+---------------------------------------+--------+----------+\n| schema   | name                                  | engine | size     |\n+----------+---------------------------------------+--------+----------+\n| sportsdb | stats                                 | InnoDB | 1.5 MB   |\n| sportsdb | participants_events                   | InnoDB | 496.0 KB |\n(truncated results for brevity)\n```\n\nShows the table size of each table in the database excluding indexes, descending by size. Additionally a table can be passed to only get the size from that table.\n\n```\nEctoMySQLExtras.table_size(MyApp.Repo, format: :ascii, args: [table: \"my_table\"])\n```\n\n### `total_index_size`\n\n```\nEctoMySQLExtras.total_index_size(MyApp.Repo, format: :ascii)\n\n+-------------------------------------------------------------+\n| Total size of all indexes (excluding PRIMARY indexes) in MB |\n+-------------------------------------------------------------+\n| size                                                        |\n+-------------------------------------------------------------+\n| 9.8 MB                                                      |\n+-------------------------------------------------------------+\n```\n\nShows the total index size of all tables in the database, primary indexes are not included.\n\n### `total_table_size`\n\n```\nEctoMySQLExtras.total_table_size(MyApp.Repo, format: :ascii)\n\n+----------------------------------------------------------------------+\n|      Size of the tables (including indexes), descending by size      |\n+----------+---------------------------------------+--------+----------+\n| schema   | name                                  | engine | size     |\n+----------+---------------------------------------+--------+----------+\n| sportsdb | stats                                 | InnoDB | 4.8 MB   |\n| sportsdb | participants_events                   | InnoDB | 1.3 MB   |\n(truncated results for brevity)\n```\n\nShows the total table size of each table in the database including indexes, descending by size. Additionally a table can be passed to only get the total size from that table.\n\n```\nEctoMySQLExtras.total_table_size(MyApp.Repo, format: :ascii, args: [table: \"my_table\"])\n```\n\n### `unused_indexes`\n\n```\nEctoMySQLExtras.unused_indexes(MyApp.Repo, format: :ascii)\n\n+-----------------------------------------------------------------------------------------------------------------+\n|                                        Unused and almost unused indexes                                         |\n+----------+--------------------------+-------------------------------------------+-------+----------+------------+\n| schema   | table                    | index                                     | pages | size     | index_hits |\n+----------+--------------------------+-------------------------------------------+-------+----------+------------+\n| sportsdb | stats                    | IDX_stats_1                               | 97    | 1.5 MB   | 0          |\n| sportsdb | events                   | IDX_FK_eve_pub_id__pub_id                 | 6     | 96.0 KB  | 0          |\n(truncated results for brevity)\n```\n\nShows all the indexes that are not used, the database should be running for a while to have the best results since it's based upon IO activity. This also requires InnoDB as engine.\n\n### `waits_for_checkpoint`\n\n```\nEctoMySQLExtras.waits_for_checkpoint(MyApp.Repo, format: :ascii)\n\n+--------------------------------------------------------------------------------------------------+\n| The ratio of how often InnoDB needs to read or create a page where no clean pages are available  |\n+---------------------------------------------+----------------------------------------------------+\n| ratio                                       | wait_counter                                       |\n+---------------------------------------------+----------------------------------------------------+\n| 0.0                                         | \"0\"                                                |\n+---------------------------------------------+----------------------------------------------------+\n```\n\nShows the ratio of how often InnoDB needs to read or create a page where no clean pages are available.\nA good ratio value should stay below 1. If `wait_counter` is greater than 0, it is a strong indicator that the InnoDB buffer pool is too small,\nand operations had to wait on a checkpoint.\n\n### `waits_for_redolog`\n\n```\nEctoMySQLExtras.waits_for_redolog(MyApp.Repo, format: :ascii)\n\n+----------------------------------+\n| The ratio of redo log contention |\n+-------------+--------------------+\n| ratio       | wait_counter       |\n+-------------+--------------------+\n| 0.0         | \"0\"                |\n+-------------+--------------------+\n```\n\nShows the ratio of redo log contention. A good ratio value should stay below 1.\nCheck `wait_counter` and if it continues to increase then it is a strong indicator that the InnoDB buffer pool is too small.\nIt can also mean that the disks are too slow and cannot sustain the disk IO, perhaps due to peak write load.\n\n> ##","ref":"readme.html#usage","title":"Usage - Overview","type":"extras"},{"doc":">\n> Some queries use the `information_schema` table which can cause performance issues when executing on a busy system. Use the `performance_schema` where possible, depending on the version and database this might not be available.","ref":"readme.html#note-info","title":"Note {: .info} - Overview","type":"extras"},{"doc":"Except for the \"obvious\" difference that `Ecto MySQL Extras` provides information on MySQL (MariaDB) databases and `Ecto PSQL Extras` on PostgreSQL databases, there are some small differences. Below is a list which could be useful if you're already using `Ecto PSQL Extras` and want to try `Ecto MySQL Extras`.\n\n* `:table_rex` is an optional dependency.\n* The default format is `:raw` instead of `:ascii`.","ref":"readme.html#ecto-mysql-extras-differences","title":"Ecto MySQL Extras differences - Overview","type":"extras"},{"doc":"- https://severalnines.com/database-blog/monitoring-percona-server-mysql-key-metrics","ref":"readme.html#query-sources","title":"Query sources - Overview","type":"extras"},{"doc":"Copyright (c) 2021 Timothy Vanderaerden\n\nLicensed under the Apache License, Version 2.0 (the \"License\");\nyou may not use this file except in compliance with the License.\nYou may obtain a copy of the License at [https://www.apache.org/licenses/LICENSE-2.0](https://www.apache.org/licenses/LICENSE-2.0).\n\nUnless required by applicable law or agreed to in writing, software\ndistributed under the License is distributed on an \"AS IS\" BASIS,\nWITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\nSee the License for the specific language governing permissions and\nlimitations under the License.","ref":"readme.html#copyright-and-license","title":"Copyright and License - Overview","type":"extras"}]}